package org.eclipse.gmt.gems.model.intelligence;
/*******************************************************************************
 * Copyright (c) 2007 Jules White. All rights reserved. This program and
 * the accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Jules White - initial API and implementation
 ******************************************************************************/
public class ConstraintEvaluationError extends RuntimeException {

	private Constraint constraint_;
	
	public ConstraintEvaluationError(Constraint con, Exception e) {
		super("The constraint : "+con+" could not be evaluated.",e);
		constraint_ = con;
	}

	public ConstraintEvaluationError(String arg0) {
		super(arg0);
		
	}

	public ConstraintEvaluationError(Throwable arg0) {
		super(arg0);
		
	}

	public ConstraintEvaluationError(String arg0, Throwable arg1) {
		super(arg0, arg1);
		
	}

	/**
	 * @return the constraint
	 */
	public Constraint getConstraint() {
		return constraint_;
	}

	/**
	 * @param constraint the constraint to set
	 */
	public void setConstraint(Constraint constraint) {
		constraint_ = constraint;
	}

	
}
