/*******************************************************************************
 * Copyright (c) 2007 Jules White. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Jules White - initial API and implementation
 ******************************************************************************/
package org.eclipse.gmt.gems.model.intelligence;


public class KBMatcher<T> implements Function<T,Boolean>{
	
	private Function<T, Boolean> matchingFunction_;
	
	public KBMatcher(Function<T, Boolean> matchingFunction) {
		super();
		matchingFunction_ = matchingFunction;
	}
	
	protected KBMatcher() {
		super();
	}

	public boolean matches(T obj){
		return apply(obj);
	}
	
	
	public Boolean apply(T arg0) {
		return matchingFunction_.apply(arg0);
	}

	public Function<T, Boolean> getMatchingFunction() {
		return matchingFunction_;
	}

	public void setMatchingFunction(Function<T, Boolean> matchingFunction) {
		matchingFunction_ = matchingFunction;
	}
	
	
}
