/*******************************************************************************
 * Copyright (c) 2007 Jules White. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Jules White - initial API and implementation
 ******************************************************************************/
package org.eclipse.gmt.gems.model.intelligence;

import java.util.Collections;
import java.util.List;
import java.util.Map;

public class SimpleMapTypeSystem implements ObjectTypeSystem {
	
	private static class MapObjectType implements ObjectType {
		
		public MapObjectType() {
			super();
		}

		
		public List<ObjectType> getDerivedTypes() {
			return Collections.EMPTY_LIST;
		}

		
		public String getName() {
			return "MapType";
		}

		
		public List<ObjectType> getSuperTypes() {
			return Collections.EMPTY_LIST;
		}

		
		public boolean instanceOf(Object obj) {
			return obj instanceof Map;
		}
		
	}
	
	public static MapObjectType MAP_OBJECT_TYPE = new MapObjectType();
	
	public static MapObjectView MAP_OBJECT_VIEW = new MapObjectView();
	
	
	public ObjectType getObjectType(Object obj) {
		return MAP_OBJECT_TYPE;
	}

	
	public ObjectView getObjectView(Object obj) {
		return MAP_OBJECT_VIEW;
	}

	
	public boolean supports(Object o) {
		return o instanceof Map;
	}

}
