package org.eclipse.gmt.gems.model.intelligence;
/*******************************************************************************
 * Copyright (c) 2007 Jules White. All rights reserved. This program and
 * the accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Jules White - initial API and implementation
 ******************************************************************************/
public class UnsupportedConstraintTypeException extends RuntimeException {

	private Constraint constraint_;
	private ConstraintEvaluator constraintEvaluator_;
	
	
	
	public UnsupportedConstraintTypeException(Constraint constraint, ConstraintEvaluator constraintEvaluator) {
		super("The constraint "+constraint+" is not supported by the constraint evaluator"+constraintEvaluator);
		constraint_ = constraint;
		constraintEvaluator_ = constraintEvaluator;
	}

	public UnsupportedConstraintTypeException() {
		super();
		// TODO Auto-generated constructor stub
	}

	public UnsupportedConstraintTypeException(String arg0, Throwable arg1) {
		super(arg0, arg1);
		// TODO Auto-generated constructor stub
	}

	public UnsupportedConstraintTypeException(String arg0) {
		super(arg0);
		// TODO Auto-generated constructor stub
	}

	public UnsupportedConstraintTypeException(Throwable arg0) {
		super(arg0);
		// TODO Auto-generated constructor stub
	}

	/**
	 * @return the constraint
	 */
	public Constraint getConstraint() {
		return constraint_;
	}

	/**
	 * @param constraint the constraint to set
	 */
	public void setConstraint(Constraint constraint) {
		constraint_ = constraint;
	}

	/**
	 * @return the constraintEvaluator
	 */
	public ConstraintEvaluator getConstraintEvaluator() {
		return constraintEvaluator_;
	}

	/**
	 * @param constraintEvaluator the constraintEvaluator to set
	 */
	public void setConstraintEvaluator(ConstraintEvaluator constraintEvaluator) {
		constraintEvaluator_ = constraintEvaluator;
	}
	
	
	
}
